Package com.io7m.coffeepick.runtime

# Class RuntimeBuild

java.lang.Object
com.io7m.coffeepick.runtime.RuntimeBuild

All Implemented Interfaces:
  `RuntimeBuildType`

    public final class RuntimeBuild
    extends java.lang.Object
    implements RuntimeBuildType

Build information.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `RuntimeBuild.Builder` | Builds instances of type `RuntimeBuild`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static RuntimeBuild.Builder` | `builder()` | Creates a builder for `RuntimeBuild`.
  `java.lang.String` | `buildNumber()` |
  `static RuntimeBuild` | `copyOf​(RuntimeBuildType instance)` | Creates an immutable copy of a `RuntimeBuildType` value.
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `RuntimeBuild` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `buildNumber`, `time`.
  `java.time.OffsetDateTime` | `time()` |
  `java.lang.String` | `toString()` | Prints the immutable value `RuntimeBuild` with attribute values.
  `RuntimeBuild` | `withBuildNumber​(java.lang.String value)` | Copy the current immutable object by setting a value for the `buildNumber` attribute.
  `RuntimeBuild` | `withTime​(java.time.OffsetDateTime value)` | Copy the current immutable object by setting a value for the `time` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### buildNumber

    public java.lang.String buildNumber()
    Specified by:
      `buildNumber` in interface `RuntimeBuildType`
    Returns:
      The build number

  - ### time

    public java.time.OffsetDateTime time()
    Specified by:
      `time` in interface `RuntimeBuildType`
    Returns:
      The build time

  - ### withBuildNumber

    public final RuntimeBuild withBuildNumber​(java.lang.String value)
    Copy the current immutable object by setting a value for the `buildNumber` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for buildNumber
    Returns:
      A modified copy of the `this` object

  - ### withTime

    public final RuntimeBuild withTime​(java.time.OffsetDateTime value)
    Copy the current immutable object by setting a value for the `time` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for time
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `RuntimeBuild` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `buildNumber`, `time`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `RuntimeBuild` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static RuntimeBuild copyOf​(RuntimeBuildType instance)
    Creates an immutable copy of a `RuntimeBuildType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable RuntimeBuild instance

  - ### builder

    public static RuntimeBuild.Builder builder()
    Creates a builder for `RuntimeBuild`.

         RuntimeBuild.builder()
            .setBuildNumber(String) // required buildNumber
            .setTime(java.time.OffsetDateTime) // required time
            .build();

    Returns:
      A new RuntimeBuild builder